package com.agagliardi.z.utils;

import java.util.Collection;

public class DivergeableBootableList<E extends Divergeable> extends
		BootableList<E> {

	private Factory<E> f = null;
	public DivergeableBootableList(Factory<E> f) {
		super();
		this.f = f;
	}

	public DivergeableBootableList(Factory<E> f,Collection<? extends E> arg0) {
		super(arg0);
		this.f = f;
	}

	private static final long serialVersionUID = -5492584556045741042L;
	private Object[][] objects;

	@Override
	public void boot() {
		super.boot();
		for (int i = 0; i < objects.length; i++) {
			add(f.newInstance());
		}
		DivergentListUtil.converge(objects, iterator());
		objects=null;
	}

	@Override
	public void compact() {
		super.compact();
		objects = DivergentListUtil.diverge(iterator(), size());
		clear();
		trimToSize();
		System.err.println(size());
	}
	
	
}
