package com.agagliardi.z.utils;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;

public class ZList<E extends Serializable> extends ZObject<List<E>> implements
		List<E>, Serializable {

	private static final long serialVersionUID = 1L;

	public ZList() {
		this(10);
	}

	public ZList(int capacity) {
		super((Bootable) new BootableList<E>(capacity));
	}

	public ZList(List<E> list) {
		super(preserveBootable(list));
	}

	private static Bootable preserveBootable(List list) {
		if(list instanceof Bootable){
			return (Bootable) list;
		}
		return (Bootable) new BootableList(list);
	}

	@Override
	public int size() {
		return super.getAlive().size();
	}

	@Override
	public boolean isEmpty() {
		return super.getAlive().isEmpty();
	}

	@Override
	public boolean contains(Object o) {
		return super.getAlive().contains(o);
	}

	@Override
	public Iterator<E> iterator() {
		return super.getAlive().iterator();
	}

	@Override
	public Object[] toArray() {
		return super.getAlive().toArray();
	}

	@Override
	public <T> T[] toArray(T[] a) {
		return super.getAlive().toArray(a);
	}

	@Override
	public boolean add(E e) {
		return super.getAlive().add(e);
	}

	@Override
	public boolean remove(Object o) {
		return super.getAlive().remove(o);
	}

	@Override
	public boolean containsAll(Collection<?> c) {
		return super.getAlive().containsAll(c);
	}

	@Override
	public boolean addAll(Collection<? extends E> c) {
		return super.getAlive().addAll(c);
	}

	@Override
	public boolean addAll(int index, Collection<? extends E> c) {
		return super.getAlive().addAll(index, c);
	}

	@Override
	public boolean removeAll(Collection<?> c) {
		return super.getAlive().removeAll(c);
	}

	@Override
	public boolean retainAll(Collection<?> c) {
		return super.getAlive().retainAll(c);
	}

	@Override
	public void clear() {
		super.getAlive().clear();
	}

	public boolean equals(E o) {
		return super.getAlive().equals(o);
	}

	@Override
	public int hashCode() {
		return super.getAlive().hashCode();
	}

	@Override
	public E get(int index) {
		return super.getAlive().get(index);
	}

	@Override
	public E set(int index, E element) {
		return super.getAlive().set(index, element);
	}

	@Override
	public void add(int index, E element) {
		super.getAlive().add(index, element);
	}

	@Override
	public E remove(int index) {
		return super.getAlive().remove(index);
	}

	@Override
	public int indexOf(Object o) {
		return super.getAlive().indexOf(o);
	}

	@Override
	public int lastIndexOf(Object o) {
		return super.getAlive().lastIndexOf(o);
	}

	@Override
	public ListIterator<E> listIterator() {
		return super.getAlive().listIterator();
	}

	@Override
	public ListIterator<E> listIterator(int index) {
		return super.getAlive().listIterator(index);
	}

	@Override
	public List<E> subList(int fromIndex, int toIndex) {
		return super.getAlive().subList(fromIndex, toIndex);
	}

}
