package com.agagliardi.z.utils.strategy;

import java.lang.ref.SoftReference;

import com.agagliardi.z.utils.Triggerable;

public class DieYoungStrategy extends ZStrategy {

	protected SoftReference<FakeGCHandler> trigger = null;

	public DieYoungStrategy(Triggerable triggerable) {
		super(triggerable);
		trigger = new SoftReference<FakeGCHandler>(new FakeGCHandler(
				triggerable));
	}

	private class FakeGCHandler {
		private Triggerable triggerable;

		public FakeGCHandler(Triggerable triggerable) {
			this.triggerable = triggerable;
			triggerable.reborn();
		}

		@Override
		protected void finalize() throws Throwable {
			triggerable.die();
		}
	}

	public final void karma() {
		if (trigger.get() == null) {
			System.err.println("Do my fate");
			trigger = new SoftReference<FakeGCHandler>(new FakeGCHandler(triggerable));
		}
	}

}
