package com.agagliardi.z.utils.strategy;

import com.agagliardi.z.utils.Triggerable;

public class WhenBellTools extends ZStrategy implements Triggerable {

	private Strategy nested;
	private long dateOfDie;
	private long lifelong = 1000 * 10;

	public WhenBellTools(Triggerable triggerable, long lifelong) {
		this(triggerable);
		this.lifelong = lifelong;
	}

	public WhenBellTools(Triggerable triggerable) {
		super(triggerable);
		dateOfDie = System.currentTimeMillis() + lifelong;
		nested = new DieYoungStrategy(this);
	}

	@Override
	public void reborn() {
		// called by nested;
		dateOfDie = System.currentTimeMillis() + lifelong;
		triggerable.reborn();
	}

	@Override
	public void die() {
		// called by nested;
		if (dateOfDie <= System.currentTimeMillis()) {
			triggerable.die();
		} else {
			System.err.println("It's not my time");
			nested = new DieYoungStrategy(this);
		}
	}

	@Override
	public void karma() {
		nested.karma();
	}

}
