package com.agagliardi.z.utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;
import java.util.List;
import java.util.Random;

import org.apache.commons.lang.time.StopWatch;

import junit.framework.TestCase;

public class ZObjectTest extends TestCase {

	public void testSimple() throws Throwable {
		ZList<String> list = new ZList<String>(10000);
		list.add("TestData1");
		list.add("TestData2");
		list.add("TestData3");
		list.die();
		list.reborn();
		System.err.println(list.get(1));
	}
	
	public void testOne() throws Throwable {
		List l = new ArrayList();
		for (int i = 0; i < 50; i++) {
			ZList<String> list = new ZList<String>(10000);
			for (int j=0;j<10000;j++){
				list.add(System.nanoTime()+"");
			}
			l.add(list);			
			System.out.println(i+"|"+list.get(0));
			Thread.sleep(1);
			System.gc();
		}
	}
	public void testSerialize() throws Throwable {
		ZList<String> list = new ZList<String>(10);
		for (int j=0;j<100;j++){
			list.add(System.nanoTime()+"");
		}
		System.err.println(list.size());
		File file = File.createTempFile("aaaa", "cxx");
		file.deleteOnExit();
		FileOutputStream fos = new FileOutputStream(file);
		ObjectOutputStream oos = new ObjectOutputStream(fos);
		oos.writeObject(list);
		oos.close();
		fos.close();
		FileInputStream fis = new FileInputStream(file);
		ObjectInputStream ois = new ObjectInputStream(fis);
		list = (ZList<String>) ois.readObject();
		ois.close();
		fis.close();
		System.err.println(list.size());
		System.err.println(list.get(9));
		//simulate gc
		list.die();
		System.err.println(list.size());
		System.err.println(list.get(9));		
		
	}
	
	public void testSerializeDivergeble() throws Throwable {
//		ZList<Element> list = new ZList<Element>(10);
		ArrayList<Element> list = new ArrayList<Element>();
		Random random = new Random();
		for (int j=0;j<500000;j++){
			list.add(new Element(random.nextDouble(),Calendar.getInstance()));
		}
		/*System.err.println(list.size());
		File file = File.createTempFile("aaaa", "cxx");
		FileOutputStream fos = new FileOutputStream(file);
		ObjectOutputStream oos = new ObjectOutputStream(fos);
		oos.writeObject(list);
		oos.close();
		fos.close();
		FileInputStream fis = new FileInputStream(file);
		ObjectInputStream ois = new ObjectInputStream(fis);
		list = (ZList<Element>) ois.readObject();
		ois.close();
		fis.close();
		System.err.println(list.size());
		System.err.println(list.get(9).getData());
		//simulate gc
		list.die();
		System.err.println(list.size());
		System.err.println(list.get(9).getData());
		list = new ZList<Element>(new DivergeableBootableList<Element>(Element.getFactory(),list.getAlive()));
		list.die();
		System.err.println(list.size());
		System.err.println(list.get(9).getData());
		*/
		double sum=0;
		StopWatch st = new StopWatch();
		st.start();
		for (Iterator iterator = list.iterator(); iterator.hasNext();) {
			Element element = (Element) iterator.next();
			sum+=element.getData();
		}
		st.stop();
		System.err.println("Sum converge:"+st.getTime());
		sum=0;
		st.reset();
		st.start();
		Object[][] objects = DivergentListUtil.diverge(list.iterator(), list.size());
		System.err.println("Diverge:"+st.getTime());
		st.stop();
		st.reset();
		st.start();
		for (int i = 0; i < objects.length; i++) {
			sum+=(Double)objects[i][0];
		}
		System.err.println("Sum diverge"+st.getTime());
		
	}	
	
	
}
